#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire3000three4xi.py">
#<abstract4xi abstract = "fires to direction three and to distance 3000"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire3000three4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2three30004xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - ) - STUBS ONLY - ALL ARE IN FILES
# -------------------------------------------------------------------------------------------------    

shot2three30004xi = {
                1:'0x2912y-721z',
                2:'1040x684y-2729z',
                3:'1059x2759y-515z',
                4:'1088x2563y-1115z',
                5:'1105x2177y-1742z',
                6:'1108x2380y-1450z',
                7:'115x275y-2985z',
                8:'119x785y-2892z',
                9:'1204x2704y-486z',
                10:'120x2368y-1996z',
                11:'1225x2512y-1087z',
                12:'1226x2132y-1717z',
                13:'1238x2331y-1424z',
                14:'125x110y-2995z',
                15:'1345x2079y-1692z',
                16:'1346x2641y-456z',
                17:'1360x2454y-1059z',
                18:'1365x2275y-1398z',
                19:'142x296y-2981z',
                20:'1462x2019y-1668z',
                21:'1484x2571y-426z',
                22:'1490x2212y-1371z',
                23:'1492x2389y-1031z',
                24:'152x2915y-692z',
                25:'155x122y-2993z',
                26:'1576x1953y-1643z',
                27:'1612x2142y-1344z',
                28:'1619x2493y-397z',
                29:'1621x2315y-1003z',
                30:'166x806y-2884z',
                31:'1687x1880y-1617z',
                32:'171x314y-2978z',
                33:'1731x2065y-1317z',
                34:'1746x2235y-975z',
                35:'174x2511y-1631z',
                36:'1750x2408y-367z',
                37:'1794x1800y-1592z',
                38:'1845x1981y-1290z',
                39:'185x131y-2991z',
                40:'1867x2148y-946z',
                41:'1875x2316y-337z',
                42:'1898x1714y-1566z',
                43:'1956x1891y-1263z',
                44:'1983x2054y-918z',
                45:'1996x2217y-307z',
                46:'1997x1622y-1541z',
                47:'19x147y-2996z',
                48:'203x330y-2974z',
                49:'2061x1794y-1236z',
                50:'2092x1525y-1515z',
                51:'2095x1953y-889z',
                52:'2112x2112y-278z',
                53:'215x824y-2876z',
                54:'2162x1691y-1209z',
                55:'2201x1847y-860z',
                56:'2221x2000y-248z',
                57:'2258x1582y-1181z',
                58:'2301x1734y-831z',
                59:'2325x1882y-218z',
                60:'236x2702y-1280z',
                61:'237x343y-2970z',
                62:'238x2302y-1908z',
                63:'2396x1616y-803z',
                64:'2422x1759y-188z',
                65:'267x839y-2867z',
                66:'273x354y-2966z',
                67:'28x38y-2999z',
                68:'2x89y-2998z',
                69:'305x2909y-662z',
                70:'307x2515y-1605z',
                71:'310x362y-2961z',
                72:'321x850y-2858z',
                73:'33x176y-2994z',
                74:'349x366y-2956z',
                75:'34x735y-2908z',
                76:'361x2305y-1885z',
                77:'376x859y-2849z',
                78:'379x2699y-1253z',
                79:'390x368y-2951z',
                80:'42x2501y-1656z',
                81:'431x366y-2946z',
                82:'433x863y-2840z',
                83:'441x2511y-1580z',
                84:'458x2896y-633z',
                85:'473x361y-2940z',
                86:'485x2301y-1861z',
                87:'492x864y-2830z',
                88:'49x203y-2992z',
                89:'49x60y-2998z',
                90:'515x352y-2934z',
                91:'522x2687y-1226z',
                92:'552x861y-2820z',
                93:'575x2500y-1554z',
                94:'609x2290y-1838z',
                95:'610x2874y-604z',
                96:'612x853y-2809z',
                97:'665x2668y-1198z',
                98:'674x842y-2799z',
                99:'68x229y-2990z',
                100:'710x2481y-1529z',
                101:'734x2273y-1814z',
                102:'736x827y-2788z',
                103:'73x79y-2998z',
                104:'75x761y-2900z',
                105:'762x2844y-574z',
                106:'797x807y-2777z',
                107:'807x2641y-1171z',
                108:'843x2455y-1503z',
                109:'859x2248y-1790z',
                110:'859x782y-2765z',
                111:'90x253y-2987z',
                112:'911x2805y-545z',
                113:'920x754y-2753z',
                114:'948x2606y-1143z',
                115:'94x2698y-1307z',
                116:'976x2421y-1477z',
                117:'981x721y-2741z',
                118:'982x2216y-1766z',
                119:'98x96y-2996z',
                120:'9x118y-2997z',
                121:'9x14y-2999z'}        
                
 
# -----------------------------------------------------------------------------------------------------------
#<function4xi function = "fire3000three4xi" usage = "target function for chargethree4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -----------------------------------------------------------------------------------------------------------
def fire3000three4xi(queue2three, consumer_channel2three, publisher_channel2three):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE3000THREE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE3000THREE4XI -  QUEUE2THREE: ", queue2three)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE3000THREE4XI -  CONSUMER_CHANNEL2THREE: ", consumer_channel2three)
        #  
              
        print("\n (STEP 1A4/33) OF FIRE3000THREE4XI -  PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE3000THREE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2three.put(shot2three30004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE3000THREE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE3000THREE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE3000THREE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4three = "<ack2put4xi>queue2three8shot2three30004xi</ack2put4xi>"
        else:
            message2send4three = "<nack2put4xi>queue2three<8shot2three30004xi/nack2put4xi>" 
            
        publisher_channel2three.send(message2send4three)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE3000THREE4XI -  SENT MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE3000THREE4XI *** FAILED TO SEND MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE3000THREE4XI - RETURNING QUEUE OBJECT QUEUE2THREE: ", queue2three, " - TIME: ", time4xi())  
        # 
            
    return queue2three    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire3000three4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                               
                